/* Copyright (C) 2001  J.A. Bezemer  -  GPL >=2  -  NO WARRANTY WHATSOEVER */

/* multicat : read file names from stdin and cat their contents to stdout */


#include <stdio.h>
#include <unistd.h>

#define BUFFERSIZE 100000
#define MAXFILENAME 500
#define USLEEPFILES 25
#define USLEEPTIME 100

int
main (int argc, char *argv[])
{
  FILE *infile;
  unsigned char buffer[BUFFERSIZE];
  char filename[MAXFILENAME];
  unsigned long filenamelen;
  unsigned long inbytes;
  unsigned long usleepcounter = USLEEPFILES;

  while (!feof (stdin))
    {
      if (fgets (filename, MAXFILENAME - 1, stdin))
	{
	  filenamelen = strlen (filename);

	  if (filename[filenamelen - 1] == '\n')
	    filename[filenamelen - 1] = '\0';

	  if ((infile = fopen (filename, "r")) != NULL)
	    {
	      while (!feof (infile))
		{
		  inbytes = fread (buffer, 1, BUFFERSIZE, infile);
		  fwrite (buffer, 1, inbytes, stdout);
		}
	      fclose (infile);
	    }

	  usleepcounter--;
	  if (usleepcounter == 0)
	    {
	      usleepcounter = USLEEPFILES;

	      /* Be a bit nice and give other processes some time */
	      usleep (USLEEPTIME);
	    }
	}
    }

  return 0;
}
