/* Copyright (C) 2001  J.A. Bezemer  -  GPL >=2  -  NO WARRANTY WHATSOEVER */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define BUFFERSIZE  25
#define MAXTERMS    25

int
main (int argc, char *argv[])
{
  char buffer[BUFFERSIZE];
  char filename[500];
  int filenameprefixlen;
  char *term[MAXTERMS];		/* strings themselves are mallocd */
  int termlen[MAXTERMS];
  int numterms = 0;
  int i, j;
  FILE *touchfile;

  if (argc < 3)
    {
      fprintf (stderr,
	       "USAGE: stdinsema <fileprefix> <string1> [<string2> ...]\n");
      return 1;
    }

  strcpy (filename, argv[1]);
  filenameprefixlen = strlen (filename);

  for (i = 0; i < (argc - 2) && i < MAXTERMS; i++)
    {
      termlen[numterms] = strlen (argv[i + 2]);
      term[numterms] = malloc (termlen[numterms] + 1);

      /* Reverse term */
      for (j = 0; j < termlen[numterms]; j++)
	(term[numterms])[termlen[numterms] - j - 1] = (argv[i + 2])[j];

      (term[numterms])[termlen[numterms]] = '\0';

      numterms++;
    }

#if 0
  for (i = 0; i < numterms; i++)
    printf ("term %d = \"%s\"\n", i, term[i]);

  return 0;
#endif

  /* Clear buffer */
  for (i = 0; i < BUFFERSIZE; i++)
    buffer[i] = '\0';

  while (!feof (stdin))
    {
      fread (&buffer, 1, 1, stdin);	/* or just read() ? */

      for (i = 0; i < numterms; i++)
	if (!strncmp (buffer, term[i], termlen[i]))
	  {
	    /* Create file name, reverse term again */
	    for (j = 0; j < termlen[i]; j++)
	      filename[filenameprefixlen + termlen[i] - j - 1] = (term[i])[j];

	    filename[filenameprefixlen + termlen[i]] = '\0';

#if 0
	    fprintf (stderr, "term %d found, creating file \"%s\"\n", i,
		     filename);
#endif

	    touchfile = fopen (filename, "a");
	    fclose (touchfile);
	  }

      /* Shift buffer */
      for (i = BUFFERSIZE - 1; i >= 1; i--)
	buffer[i] = buffer[i - 1];
    }

  return 0;
}
